"""
    Zinc Search engine API

    Zinc Search engine API documents https://docs.zincsearch.com  # noqa: E501

    The version of the OpenAPI document: 0.2.4
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from zincsearch_sdk.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from zincsearch_sdk.exceptions import ApiAttributeError


def lazy_import():
    from zincsearch_sdk.model.meta_bool_query import MetaBoolQuery
    from zincsearch_sdk.model.meta_exists_query import MetaExistsQuery
    from zincsearch_sdk.model.meta_fuzzy_query import MetaFuzzyQuery
    from zincsearch_sdk.model.meta_ids_query import MetaIdsQuery
    from zincsearch_sdk.model.meta_match_bool_prefix_query import MetaMatchBoolPrefixQuery
    from zincsearch_sdk.model.meta_match_phrase_prefix_query import MetaMatchPhrasePrefixQuery
    from zincsearch_sdk.model.meta_match_phrase_query import MetaMatchPhraseQuery
    from zincsearch_sdk.model.meta_match_query import MetaMatchQuery
    from zincsearch_sdk.model.meta_multi_match_query import MetaMultiMatchQuery
    from zincsearch_sdk.model.meta_prefix_query import MetaPrefixQuery
    from zincsearch_sdk.model.meta_query_string_query import MetaQueryStringQuery
    from zincsearch_sdk.model.meta_range_query import MetaRangeQuery
    from zincsearch_sdk.model.meta_regexp_query import MetaRegexpQuery
    from zincsearch_sdk.model.meta_simple_query_string_query import MetaSimpleQueryStringQuery
    from zincsearch_sdk.model.meta_term_query import MetaTermQuery
    from zincsearch_sdk.model.meta_wildcard_query import MetaWildcardQuery
    globals()['MetaBoolQuery'] = MetaBoolQuery
    globals()['MetaExistsQuery'] = MetaExistsQuery
    globals()['MetaFuzzyQuery'] = MetaFuzzyQuery
    globals()['MetaIdsQuery'] = MetaIdsQuery
    globals()['MetaMatchBoolPrefixQuery'] = MetaMatchBoolPrefixQuery
    globals()['MetaMatchPhrasePrefixQuery'] = MetaMatchPhrasePrefixQuery
    globals()['MetaMatchPhraseQuery'] = MetaMatchPhraseQuery
    globals()['MetaMatchQuery'] = MetaMatchQuery
    globals()['MetaMultiMatchQuery'] = MetaMultiMatchQuery
    globals()['MetaPrefixQuery'] = MetaPrefixQuery
    globals()['MetaQueryStringQuery'] = MetaQueryStringQuery
    globals()['MetaRangeQuery'] = MetaRangeQuery
    globals()['MetaRegexpQuery'] = MetaRegexpQuery
    globals()['MetaSimpleQueryStringQuery'] = MetaSimpleQueryStringQuery
    globals()['MetaTermQuery'] = MetaTermQuery
    globals()['MetaWildcardQuery'] = MetaWildcardQuery


class MetaQuery(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'bool': (MetaBoolQuery,),  # noqa: E501
            'exists': (MetaExistsQuery,),  # noqa: E501
            'fuzzy': ({str: (MetaFuzzyQuery,)},),  # noqa: E501
            'ids': (MetaIdsQuery,),  # noqa: E501
            'match': ({str: (MetaMatchQuery,)},),  # noqa: E501
            'match_all': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'match_bool_prefix': ({str: (MetaMatchBoolPrefixQuery,)},),  # noqa: E501
            'match_none': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'match_phrase': ({str: (MetaMatchPhraseQuery,)},),  # noqa: E501
            'match_phrase_prefix': ({str: (MetaMatchPhrasePrefixQuery,)},),  # noqa: E501
            'multi_match': (MetaMultiMatchQuery,),  # noqa: E501
            'prefix': ({str: (MetaPrefixQuery,)},),  # noqa: E501
            'query_string': (MetaQueryStringQuery,),  # noqa: E501
            'range': ({str: (MetaRangeQuery,)},),  # noqa: E501
            'regexp': ({str: (MetaRegexpQuery,)},),  # noqa: E501
            'simple_query_string': (MetaSimpleQueryStringQuery,),  # noqa: E501
            'term': ({str: (MetaTermQuery,)},),  # noqa: E501
            'terms': ({str: (dict,)},),  # noqa: E501
            'wildcard': ({str: (MetaWildcardQuery,)},),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'bool': 'bool',  # noqa: E501
        'exists': 'exists',  # noqa: E501
        'fuzzy': 'fuzzy',  # noqa: E501
        'ids': 'ids',  # noqa: E501
        'match': 'match',  # noqa: E501
        'match_all': 'match_all',  # noqa: E501
        'match_bool_prefix': 'match_bool_prefix',  # noqa: E501
        'match_none': 'match_none',  # noqa: E501
        'match_phrase': 'match_phrase',  # noqa: E501
        'match_phrase_prefix': 'match_phrase_prefix',  # noqa: E501
        'multi_match': 'multi_match',  # noqa: E501
        'prefix': 'prefix',  # noqa: E501
        'query_string': 'query_string',  # noqa: E501
        'range': 'range',  # noqa: E501
        'regexp': 'regexp',  # noqa: E501
        'simple_query_string': 'simple_query_string',  # noqa: E501
        'term': 'term',  # noqa: E501
        'terms': 'terms',  # noqa: E501
        'wildcard': 'wildcard',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """MetaQuery - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            bool (MetaBoolQuery): [optional]  # noqa: E501
            exists (MetaExistsQuery): [optional]  # noqa: E501
            fuzzy ({str: (MetaFuzzyQuery,)}): simple, PrefixQuery. [optional]  # noqa: E501
            ids (MetaIdsQuery): [optional]  # noqa: E501
            match ({str: (MetaMatchQuery,)}): simple, MatchQuery. [optional]  # noqa: E501
            match_all (bool, date, datetime, dict, float, int, list, str, none_type): [optional]  # noqa: E501
            match_bool_prefix ({str: (MetaMatchBoolPrefixQuery,)}): simple, MatchBoolPrefixQuery. [optional]  # noqa: E501
            match_none (bool, date, datetime, dict, float, int, list, str, none_type): [optional]  # noqa: E501
            match_phrase ({str: (MetaMatchPhraseQuery,)}): simple, MatchPhraseQuery. [optional]  # noqa: E501
            match_phrase_prefix ({str: (MetaMatchPhrasePrefixQuery,)}): simple, MatchPhrasePrefixQuery. [optional]  # noqa: E501
            multi_match (MetaMultiMatchQuery): [optional]  # noqa: E501
            prefix ({str: (MetaPrefixQuery,)}): .. [optional]  # noqa: E501
            query_string (MetaQueryStringQuery): [optional]  # noqa: E501
            range ({str: (MetaRangeQuery,)}): simple, FuzzyQuery. [optional]  # noqa: E501
            regexp ({str: (MetaRegexpQuery,)}): simple, FuzzyQuery. [optional]  # noqa: E501
            simple_query_string (MetaSimpleQueryStringQuery): [optional]  # noqa: E501
            term ({str: (MetaTermQuery,)}): simple, TermQuery. [optional]  # noqa: E501
            terms ({str: (dict,)}): .. [optional]  # noqa: E501
            wildcard ({str: (MetaWildcardQuery,)}): simple, WildcardQuery. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """MetaQuery - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            bool (MetaBoolQuery): [optional]  # noqa: E501
            exists (MetaExistsQuery): [optional]  # noqa: E501
            fuzzy ({str: (MetaFuzzyQuery,)}): simple, PrefixQuery. [optional]  # noqa: E501
            ids (MetaIdsQuery): [optional]  # noqa: E501
            match ({str: (MetaMatchQuery,)}): simple, MatchQuery. [optional]  # noqa: E501
            match_all (bool, date, datetime, dict, float, int, list, str, none_type): [optional]  # noqa: E501
            match_bool_prefix ({str: (MetaMatchBoolPrefixQuery,)}): simple, MatchBoolPrefixQuery. [optional]  # noqa: E501
            match_none (bool, date, datetime, dict, float, int, list, str, none_type): [optional]  # noqa: E501
            match_phrase ({str: (MetaMatchPhraseQuery,)}): simple, MatchPhraseQuery. [optional]  # noqa: E501
            match_phrase_prefix ({str: (MetaMatchPhrasePrefixQuery,)}): simple, MatchPhrasePrefixQuery. [optional]  # noqa: E501
            multi_match (MetaMultiMatchQuery): [optional]  # noqa: E501
            prefix ({str: (MetaPrefixQuery,)}): .. [optional]  # noqa: E501
            query_string (MetaQueryStringQuery): [optional]  # noqa: E501
            range ({str: (MetaRangeQuery,)}): simple, FuzzyQuery. [optional]  # noqa: E501
            regexp ({str: (MetaRegexpQuery,)}): simple, FuzzyQuery. [optional]  # noqa: E501
            simple_query_string (MetaSimpleQueryStringQuery): [optional]  # noqa: E501
            term ({str: (MetaTermQuery,)}): simple, TermQuery. [optional]  # noqa: E501
            terms ({str: (dict,)}): .. [optional]  # noqa: E501
            wildcard ({str: (MetaWildcardQuery,)}): simple, WildcardQuery. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
